 member
!Slider v5.0
!Copyright  1999,1998,1997 J & S Software Co. - All Rights Reserved WorldWide
  include('keycodes.clw')
SelectorBuffer Equate( 6 )!Units around the slider knob for the "selector rectangle"

  map
   Odd( ? Number ), Byte !Tests for odd number
   Module('Win API Functions')
     jsDrawFocusRect(UNSigned, *GROUP),PASCAL,RAW, NAME('DrawFocusRect')
     jsGetDC(UNSIGNED),UNSIGNED,PASCAL,NAME('GetDC')                                
     jsReleaseDC(UNSIGNED,UNSIGNED),SIGNED,PASCAL,NAME('ReleaseDC')                 
     jsGetClientRect(UNSIGNED,*GROUP),RAW,PASCAL,NAME('GetClientRect')
     jsGetCursorPos(*JSPOINT),BOOL,PASCAL,NAME('GetCursorPos')
   end
  end
!MODULE DATA-------------------------------
MOD:hWnd  Signed               !Module Data for storing a HANDLE
MOD:hDC   Signed               !Module Data for storing a hDC
MOD:Rect  Group                !A standard RECT structure. Passed to the GetClientRect() and DrawfocusRect() api functions
X           Signed             !X position of the Rectangle
Y           Signed             !Y position of the Rectangle
LRX         Signed             !X position of the Rectangle's lower right corner
LRY         Signed             !Y position of the Rectangle's lower right corner
          end
  include('jsslid50.inc')        !Includes the Slider Class Declarations
!**************************************************************************************************************************
!Slider Class
!**************************************************************************************************************************
SliderClass.PreInit Procedure
!Gets overridden by either Vertical or Horizontal Class
 Code
!--------------------------------------------------------------------------------------------------------------------------
SliderClass.init Function( ? InitValue, ? SliderMax , ? SliderMin , JSSIG IG )
!
!This Function initializes all of the data members for the CLASS using the data passed,
!and by calculating size and position data from the controls used.
!Also, methods are executed which create other needed controls and draw the graduation tick marks.
!
LOC:TestVar  Real
LOC:AdjustVar Real
 Code

 Self.PreInit                     !Set m_PosProp and m_SizeProp, depending on HORIZ or VERT
 Self.m_SliderMax = SliderMax     !Set the maximum return value for the slider
 Self.m_Slidermin = SliderMin     !Set the minimum return value for the slider
 Self.m_SliderCTL = IG.SliderCTL  !The field number for the "track"
 Self.m_KnobCTL = IG.KnobCTL      !The field number for the "knob"

 If IG.AdjustOK                   !This code re-sizes the "track" to be evenly divided for "tick marks"
   LOC:AdjustVar = Self.m_SliderCTL{Self.m_SizeProp} / (IG.Graduations-1 )         !Look at the current unit size
   If LOC:AdjustVar <> INT(LOC:AdjustVar)                                          !If the track cannot be evenly divided
      Self.m_SliderCTL{Self.m_SizeProp} = INT(LOC:AdjustVar) * (IG.Graduations-1)  !then make it evenly dividable
   end
 end

 If ~IG.KnobSize
   Self.m_KnobCTL{Self.m_SizeProp} = Self.m_KnobCTL{Self.m_SizeProp} + Odd( Self.m_KnobCTL{Self.m_SizeProp} )!Make the size an EVEN Number
   Self.m_KnobCenter = Self.m_KnobCTL{Self.m_SizeProp} / 2 !The center of the knob.
 else                                                      !The knob size was specifiied
   IG.KnobSize += Odd( IG.KnobSize )                       !Make sure that the size is an even number so that there is an exact center.
   Self.m_KnobCTL{Self.m_SizeProp} = IG.KnobSize           !Set the size of the knob to the specified size
   Self.m_KnobCenter = IG.KnobSize / 2                     !The center of the knob
 end
 Self.m_SliderMinPos = Self.m_SliderCTL{Self.m_PosProp} - Self.m_KnobCenter !The minimum position
 Self.m_SliderMaxPos = Self.m_SliderCTL{Self.m_PosProp} + Self.m_SliderCTL{Self.m_SizeProp} - Self.m_KnobCenter !The maximum position
 Self.m_KnobColor = Self.m_KnobCTL{PROP:Fill}              !Store the fill color of the knob
 Self.m_KnobCTL{PROP:DragID} = 'DragId'                    !Give the knob a dragid so that it can be dragged. The actual ID is not important because there won't be a "drop".
 Self.m_KnobCTL{PROP:IMM} = true                           !Set the IMMEDIATE attribute so the desired EVENTs are generated.
 Self.m_IsSliding = False                                  !flag to say if we are currently sliding
 Self.m_KnobCTL{PROP:ToolTip} = IG.ToolTip
 If Initvalue < self.m_sliderMin                           !Make sure that the initial value of the variable is within limits
    Initvalue = self.m_sliderMin
 end
 If Initvalue > self.m_sliderMax
    Initvalue = self.m_sliderMax
 end
 self.CreateCTLS( IG )                                     !Create the extra controls needed for the slider.
 self.m_graduations = IG.graduations                       !Set the number of tick marks desired.
 self.m_TopLeftTicks = IG.TopLeftTicks
 self.m_BottomRightTicks = IG.BottomRightTicks
 self.m_GradSize = IG.GradSize
 self.Graduate                                             !Draw the tick marks
 self.m_TickLock = IG.TickLock
 Self.Sync( InitValue )                                    !Syncronize the position of the slider to represent the initial value.
 If IG.LargeScroll
    Self.m_LargeUnits = (Self.m_SliderMaxPos - Self.m_SliderMinPos) * (IG.LargeScroll / (Self.m_SliderMax - self.m_SliderMin))
 else
    Self.m_LargeUnits = Self.m_KnobCTL{Self.m_SizeProp}
 end
 If IG.SmallScroll
    Self.m_SmallUnits = (Self.m_SliderMaxPos - Self.m_SliderMinPos) * (IG.SmallScroll / (Self.m_SliderMax - self.m_SliderMin))
    If Self.m_SmallUnits < 1
       Self.m_SmallUnits = 1
    end
 else
    Self.m_SmallUnits = 1
 end
 Post( Event:MouseUp, self.m_knobctl)                      !Forces a calculation of the value in case there is not an exact match.

 Return                               !Return the next safe number for creating in case there are more sliders to be initialized.
!--------------------------------------------------------------------------------------------------------------------------
SliderClass.Sync Procedure( ? InitValue )
! Gets overridden by either the Vertical or Horizontal class
 Code
!--------------------------------------------------------------------------------------------------------------------------
SliderClass.EventHandler    Function( *? SliderUse )
! If any of the 3 "active" controls of the slider generate an event, this procedure initiates the appropriate action,
! depending on the control and event.
!
NewPos         Short
ReturnVal      Byte
LOC:CheckVal   Real
  Code
    Case Field()
    of self.m_ClickCTL             !If an event was generated from the clickable transparent region
      if event() = event:accepted  !and it was a mouseclick
       self.Select                 !Make sure that the slider is "selected"
       self.ClickEvent             !call the mouse click handling method
      end
    of Self.m_SelectCTL            !If an event was generated from the "selectable" control (entry)
       Case Event()
       of event:alertkey           !If one of the alert keys was pressed
         self.KeyEvent             !call the key handling method
       of event:selected           !If it was selected
         Self.m_SelectCTL{PROP:Touched} = true !Set PROP:Touched to true so that an ACCEPTED event will be forced when the control loses focus
         IF ~Self.m_IsVisible         ! Is the select box not visible
            Self.SelectBox                        !Draw the select box
            Self.m_IsVisible = 1      ! Set Visible to true
         END
       of event:accepted                       !If the control has lost focus
         IF Self.m_IsVisible                     ! Is the Select Box visible
            Self.SelectBox                        !Clear the select box
            CLEAR(Self.m_IsVisible)               ! Clear the visible flag
         END
       end
       Self.SettoPosition(Self.m_KnobCTL{self.m_posprop}) !Re-position the controls.
    of Self.m_KnobCTL              !If an event is generated from the knob control.
       Case Event()
       of event:dragging orof event:Accepted  !If dragging or clicked by the mouse
         Disable( self.m_ClickCTL )           !Disable the clickable transparent region to avoid event conflicts
         self.select                          !Make sure that the slider is currently selected 
         self.m_knobCtl{PROP:Fill} = 0D6D6D6H !Change the knob color
          If Event() = Event:accepted
            If ~Self.m_IsSliding              !If the IsSliding flag has not yet been set
              Self.m_MouseOffset = Self.MousePos() - Self.m_KnobCtl{Self.m_PosProp} !Save the offset between the mouse position and the knob position
            end
          end
         Self.m_IsSliding = true              !Let the entire class know that we are now in "sliding" mode
         SetCursor( Cursor:Arrow )            !Make sure that the "dragging" cursor does not appear
       of event:mousemove orof event:mousein orof event:mouseout !If there is any mouse movement over the knob
         If Self.m_IsSliding                  !Only do something if we are currently "sliding"
           Case Self.MousePos()               !Depending on the position of the mouse
            of -100000 to Self.m_SliderMinPos !If the mouse position is anything less than the minimum position
              NewPos = Self.m_SliderMinPos    !Then set it to the minimum position
            of  Self.m_SliderMaxPos + Self.m_MouseOFFSet to 100000 !If the mouse position is anything more than the maximum position
              NewPos = Self.m_SliderMaxPos    !Then set the knob position to the maximum position
            else                              !Otherwise
              NewPos = Self.MousePos() - Self.m_MouseOffset !The new knob position will be the mouse position minus the previously saved offset
            end
            Self.CheckRange( NewPos )   !WUZ
            Self.SetToPosition( NewPos )      !Set the knob and selectable control to the new position
         end
       of event:mouseup orof event:drop       !If the mouse button is released or an EVENT:Drop is fired
         self.m_knobctl{PROP:Fill} = Self.m_KnobColor !Restore the knob color
         Self.m_IsSliding = False             !We are no longer sliding
         enable( self.m_ClickCTL )            !Re-enable the clickable region
         SetCursor                            !Reset the cursor

       end
     end
        ReturnVal = False                     !Initialize the return value
        LOC:CheckVal = SliderUse              !Copy the old slider USE value to a REAL variable
        SliderUse = Self.SliderVal()          !Set the slider USE variable to the new value based upon the knob position
        If (SliderUse <> LOC:CheckVal)        !If the value has changed then
           ReturnVal = True                   !let the calling procedure know in case some action needs to be done
        end
        Return(ReturnVal)                     !Return the result
!--------------------------------------------------------------------------------------------------------------------------
SliderClass.Kill   Procedure
!This method is reserved for future use. (For clean up purposes)

 Code

!--------------------------------------------------------------------------------------------------------------------------
SliderClass.MousePos Function()
! Gets overridden by either vertical or horizontal class. When Horizontal, it will return MouseX().
! When vertical, it will return MouseY().
 Code

  Return(0)
!--------------------------------------------------------------------------------------------------------------------------
SliderClass.SetToPosition Procedure( Long NewPos )
! Gets overridden by either vertical or horizontal class. When Horizontal sets the X-Position. When Vertical,
! sets the Y-Position.
 Code
!--------------------------------------------------------------------------------------------------------------------------
SliderClass.SliderVal     Function()
!Gets overridden by either vertical or horizontal class because the means of calculation are different.
 Code

 Return(0)
!--------------------------------------------------------------------------------------------------------------------------
SliderClass.Select   Procedure
!Selects the control that is "selectable"
 Code

  Select( Self.m_SelectCTL )
!--------------------------------------------------------------------------------------------------------------------------
SliderClass.Field  Function
RetVal LONG
 Code
 Case Field()
 of self.m_KnobCTL  orof self.m_ClickCTL orof self.m_SelectCTL !If the field belongs to this slider
   RetVal = Field()!Return the field
 else
   RetVal = -10000 !If the field doesn't belong to this class, returns a bogus number. If it were to return ZERO, then
                   !it could potentially cause a conflict because the WINDOW is always ZERO.
 end
 Return( RetVal )
!--------------------------------------------------------------------------------------------------------------------------
SliderClass.CreateCTLS   Procedure(*JSSIG IG)
! Gets overridden by the Vertical or Horizontal classes. Creates the extra controls needed by the slider
  Code

!--------------------------------------------------------------------------------------------------------------------------
SliderClass.KeyEvent   Procedure
!Handles any ALERTKY events on the "selectable" control.

NewPos Short

  Code

   Case Keycode()
   of LeftKey orof UpKey
      NewPos = Self.m_KnobCTL{self.m_PosProp} - Self.m_SmallUnits
   of RightKey orof DownKey
      NewPos = Self.m_KnobCTL{self.m_PosProp} + Self.m_SmallUnits
   of PgUpKey
      NewPos = Self.m_KnobCTL{self.m_PosProp} - Self.m_LargeUnits
   of PgDnKey
      NewPos = Self.m_KnobCTL{self.m_PosProp} + Self.m_LargeUnits
   of HomeKey
      NewPOS = Self.m_SliderMinPOS
   of EndKey
      NewPOS = Self.m_SliderMaxPOS
   end
   Self.CheckRange( NewPos )     !Assure that the new position is within range
   Self.SetToPosition( NewPos )  !Set controls to new position


!--------------------------------------------------------------------------------------------------------------------------
SliderClass.ClickEvent   Procedure
!Handles any mouse clicks to the "clickable" control.
NewPos Short
 Code
   Case Self.MousePos()
   of -10000 to Self.m_KnobCTL{self.m_PosProp}
      NewPos = Self.m_KnobCTL{self.m_PosProp} - Self.m_LargeUnits
   of ( Self.m_KnobCTL{self.m_PosProp} + Self.m_KnobCTL{Self.m_SizeProp}) to 100000
      NewPos = Self.m_KnobCTL{self.m_PosProp} + Self.m_LargeUnits
   else
      NewPos = Self.m_KnobCTL{self.m_PosProp}
   end

   Self.CheckRange( NewPos )    !Assure that the new position is within range
   Self.SetToPosition( NewPos ) !Set controls to new position

!--------------------------------------------------------------------------------------------------------------------------
SliderClass.Graduate  Procedure
!Overridden by the Horizontal and Vertical classes. Draws the "tick mark"s.
  Code

!--------------------------------------------------------------------------------------------------------------------------
SliderClass.SelectBox Procedure
!Draws the "Selected" dotted-line box. The DrawFocusRect() api call is a XOR operation. It draws the rect if it doesn't exist
!and it clears the rect if it does exist.
 Code
   MOD:hWnd = Self.m_ClickCTL{PROP:Handle}  !Save the handle of the clickable control to a variable
   MOD:hDC = jsGetDC(MOD:hWnd)              !Use the handle to get a DC
   jsGetClientRect(MOD:hWnd, MOD:Rect )     !Get the rectangle positions of the clickable control
   jsDrawFocusRect(MOD:hDC, MOD:Rect)       !Draw the rectangle (or clear if already drawn)
   If jsReleaseDC( MOD:hWnd, MOD:hDC ).     !Release the DC

!--------------------------------------------------------------------------------------------------------------------------
SliderClass.CheckRange    Procedure( *SHORT NewPos )
!This is a "just to be sure" procedure. Makes sure that a position is within the allowable range.
LOC:Min             SHORT
LOC:Max             SHORT
LOC:GradDistance    SHORT
  Code

    If NewPos < Self.m_SliderMinPOS   !One last check to make sure that the new position is within min and max positions
      NewPOS = Self.m_SliderMinPOS
    end
    If NewPos > Self.m_SliderMaxPOS
      NewPOS = Self.m_SliderMaxPOS
    end

    If Self.m_TickLock AND Self.m_Graduations
       LOC:Min = Self.m_SliderCTL{Self.m_PosProp}
       LOC:Max = Self.m_SliderCTL{Self.m_PosProp} + Self.m_SliderCTL{Self.m_SizeProp}
       LOC:GradDistance = (LOC:Max - LOC:Min) / ( self.m_Graduations - 1)
       IF ((NewPOS - Self.m_SliderMinPOS) % Loc:GradDistance) <> 0
         NewPOS = self.m_SliderMinPOS + (Loc:GradDistance * (ROUND(((NewPOS - Self.m_SliderMinPos) / Loc:GradDistance),1) ))
            If NewPos < Self.m_SliderMinPOS   !One last check to make sure that the new position is within min and max positions
                NewPOS = Self.m_SliderMinPOS
            end
            If NewPos > Self.m_SliderMaxPOS
                NewPOS = Self.m_SliderMaxPOS
            end
       ELSE
       END
    END

!==============================================================================================================================
!Vertical Slider Overriding Methods
!==============================================================================================================================
VSlider:Class.PreInit Procedure
!Sets the size and position members to use only vertical properties
 Code
 Self.m_SizeProp = PROP:Height
 Self.m_PosProp  = PROP:YPos

!--------------------------------------------------------------------------------------------------------------------------
VSlider:Class.Sync Procedure( ? InitValue )
!Positions the knob according to a pre-existing value of the slider USE variable
LOC:Percentage  real
LOC:Range       Long
LOC:NewPos      Long
 Code
   LOC:Range = self.m_slidermax-self.m_slidermin
   LOC:Percentage = ( LOC:Range - (self.m_slidermax - InitValue))/LOC:Range
   LOC:NewPos = Self.m_SliderCTL{Self.m_SizeProp}-(LOC:Percentage * Self.m_SliderCtl{Self.m_SizeProp}) + Self.m_SliderCTL{Self.m_PosProp}
   Self.SetToPosition( LOC:NewPos - Self.m_KnobCenter )

!--------------------------------------------------------------------------------------------------------------------------
VSlider:Class.MousePos Function()
!Since we are a vertical slider, we only care about the vertical mouse positions
Loc:MouseY  SHORT
 Code
  Loc:MouseY = MouseY()
  Return( Loc:MouseY )
!--------------------------------------------------------------------------------------------------------------------------
VSlider:Class.SetToPosition Procedure( Long NewPos )
!Sets the positions of the knob and selectable control
  Code
  SetPosition( self.m_SelectCTL,self.m_KnobCTL{PROP:XPos} + 1 , NewPos + 1 )
  SetPosition( Self.m_KnobCTL, , NewPos )

!--------------------------------------------------------------------------------------------------------------------------
VSlider:Class.SliderVal     Function()
!Based on the knob position, returns the value
ReturnVal  Real
 Code

 ReturnVal = (Self.m_SliderMax-Self.m_SliderMin) - ((((Self.m_KnobCtl{Self.m_PosProp}-Self.m_SliderMinPos) ) /|
                Self.m_SliderCTL{Self.m_SizeProp}) * (Self.m_SliderMax - Self.m_SLiderMin)) + Self.m_SliderMin

 Return( ReturnVal )
!--------------------------------------------------------------------------------------------------------------------------
VSlider:Class.CreateCTLS   Procedure(*JSSIG IG)
!Creates the extra controls needed by the slider
LOC:Parent Short
  Code

  LOC:Parent = 0
  If IG.Parent
    LOC:Parent = IG.Parent
  end
  self.m_SelectCTL = Create(0, Create:Entry, LOC:Parent )
  self.m_SelectCTL{PROP:Text} = '@s1'
  self.m_SelectCTL{PROP:ALRT,1} = UpKey
  self.m_SelectCTL{PROP:ALRT,2} = DownKey
  self.m_SelectCTL{PROP:ALRT,3} = PgUpKey
  self.m_SelectCTL{PROP:ALRT,4} = PgDnKey
  self.m_SelectCTL{PROP:ALRT,5} = LeftKey
  self.m_SelectCTL{PROP:ALRT,6} = RightKey
  self.m_SelectCTL{PROP:ALRT,7} = HomeKey
  self.m_SelectCTL{PROP:ALRT,8} = EndKey
  self.m_SelectCTL{PROP:ALRT,9} = SpaceKey
  SetPosition( self.m_SelectCTL, Self.m_KnobCTL{PROP:XPos}, Self.m_KnobCTL{PROP:YPos}, 0, 0 )
  self.m_SelectCTL{PROP:Follows} = Self.m_SliderCTL
  self.m_SelectCTL{PROP:MSG} = IG.MSG
  UnHide( self.m_SelectCTL )
  self.m_ClickCTL = Create(0,Create:Region, LOC:Parent )
  self.m_ClickCTL{PROP:IMM} = True
  SetPosition( self.m_ClickCTL, Self.m_KnobCTL{PROP:XPos}-SelectorBuffer, Self.m_SliderCTL{Prop:YPos}-(self.m_knobcenter*2), |
               Self.m_KnobCTL{PROP:Width}+ (SelectorBuffer * 2 ), Self.m_SliderCTL{PROP:Height}+(self.m_knobcenter*4))
  Self.m_ClickCTL{PROP:ToolTip} = IG.ToolTip
  Unhide(self.m_ClickCTL)


!--------------------------------------------------------------------------------------------------------------------------
VSlider:Class.Graduate  Procedure
!Draws the tick marks
LoopCounter  Short
LOC:Min      Short
LOC:Max      Short
LOC:GradDistance Short
  Code
  If self.m_Graduations
     LOC:Min = Self.m_SliderCTL{Self.m_PosProp}
     LOC:Max = Self.m_SliderCTL{Self.m_PosProp} + Self.m_SliderCTL{Self.m_SizeProp}
     LOC:GradDistance = (LOC:Max - LOC:Min) / ( self.m_Graduations - 1)
     SetPenColor(COLOR:BtnText)
     Loop LoopCounter = LOC:Max to LOC:Min by -LOC:GradDistance
       If self.m_TopLeftTicks
            Line( self.m_knobCTL{PROP:XPos}, LoopCounter, -Self.m_GradSize, 0)
       end
       If self.m_BottomRightTicks
            Line( self.m_knobCTL{PROP:XPos} + 14, LoopCounter, Self.m_GradSize, 0)
       end
     end
     SetPenColor()
  else
    Return
  end
!==============================================================================================================================
!Horizontal Slider Overriding Methods
!==============================================================================================================================
HSlider:Class.PreInit Procedure
!Since this is a horizontal slider, we only care about horizontal stuff.
  Code
 Self.m_SizeProp = PROP:Width
 Self.m_PosProp  = PROP:XPos
!--------------------------------------------------------------------------------------------------------------------------
HSlider:Class.Sync  Procedure( ? InitValue )
!Sets the position of the slider knob based upon a pre-existing value of the USE variable.
LOC:Percentage  real
LOC:Range       Long
LOC:NewPos      Long
 Code
   LOC:Range = self.m_slidermax-self.m_slidermin
   LOC:Percentage = ( LOC:Range - (self.m_slidermax - InitValue))/LOC:Range
   LOC:NewPos = (LOC:Percentage * Self.m_SliderCtl{Self.m_SizeProp}) + Self.m_SliderMinPos
   Self.SetToPosition( LOC:NewPos  )

!--------------------------------------------------------------------------------------------------------------------------
HSlider:Class.MousePos Function()
!Returns the horizontal mouse position
Loc:MouseX  SHORT
 Code
  Loc:MouseX = MouseX()
  Return( Loc:MouseX )

!--------------------------------------------------------------------------------------------------------------------------
HSlider:Class.SetToPosition Procedure( Long NewPos )
!Sets the positions of the knob and selectable controls
  Code
  SetPosition( self.m_SelectCTL,NewPos + 1,self.m_KnobCTL{PROP:YPos} + 1   )
  SetPosition( Self.m_KnobCTL, NewPos )

!--------------------------------------------------------------------------------------------------------------------------
HSlider:Class.SliderVal     Function()
!Returns a value based upon the position of the slider knob.
ReturnVal Real
 Code

 ReturnVal = ((((Self.m_KnobCtl{Self.m_PosProp}-Self.m_SliderMinPos) ) /|
                Self.m_SliderCTL{Self.m_SizeProp}) * (Self.m_SliderMax - Self.m_SLiderMin)) + Self.m_SliderMin

 Return( ReturnVal )

!--------------------------------------------------------------------------------------------------------------------------
HSlider:Class.CreateCTLS   Procedure(*JSSIG IG)
!Creates the extra controls needed by the slider
LOC:Parent  Short
  Code
  LOC:Parent = 0
  If IG.Parent
    LOC:Parent = IG.Parent
  end
  self.m_SelectCTL = Create(0, Create:Entry, LOC:Parent )
  self.m_SelectCTL{PROP:Text} = '@s1'
  self.m_SelectCTL{PROP:ALRT,1} = UpKey
  self.m_SelectCTL{PROP:ALRT,2} = DownKey
  self.m_SelectCTL{PROP:ALRT,3} = PgUpKey
  self.m_SelectCTL{PROP:ALRT,4} = PgDnKey
  self.m_SelectCTL{PROP:ALRT,5} = LeftKey
  self.m_SelectCTL{PROP:ALRT,6} = RightKey
  self.m_SelectCTL{PROP:ALRT,7} = HomeKey
  self.m_SelectCTL{PROP:ALRT,8} = EndKey
  self.m_SelectCTL{PROP:ALRT,9} = SpaceKey
  SetPosition( self.m_SelectCTL, Self.m_KnobCTL{PROP:XPos}, Self.m_KnobCTL{PROP:YPos}, 0, 0 )
  self.m_SelectCTL{PROP:Follows} = Self.m_SliderCTL
  self.m_SelectCTL{PROP:MSG} = IG.MSG
  UnHide( self.m_SelectCTL )
  self.m_ClickCTL = Create(0, Create:Region, LOC:Parent )
  self.m_ClickCTL{PROP:IMM} = True
  SetPosition( self.m_ClickCTL, Self.m_SliderCTL{PROP:XPos}-(self.m_knobcenter*2), Self.m_knobCTL{Prop:YPos}-SelectorBuffer, |
               Self.m_SliderCTL{PROP:Width}+(self.m_knobcenter*4), Self.m_KnobCTL{PROP:Height}+ (SelectorBuffer * 2))
  self.m_ClickCTL{PROP:ToolTip} = IG.ToolTip
  unhide( self.m_ClickCTL )

!--------------------------------------------------------------------------------------------------------------------------
HSlider:Class.Graduate  Procedure
!Draws the "tick marks"
LoopCounter  Short
LOC:Min      Short
LOC:Max      Short
LOC:GradDistance Short
  Code
  If self.m_Graduations
     LOC:Min = Self.m_SliderCTL{Self.m_PosProp}
     LOC:Max = Self.m_SliderCTL{Self.m_PosProp} + Self.m_SliderCTL{Self.m_SizeProp} 
     LOC:GradDistance = (LOC:Max - LOC:Min) / ( self.m_Graduations - 1)
     SetPenColor(COLOR:BtnText)
     Loop LoopCounter = LOC:Min to LOC:Max by LOC:GradDistance
       If self.m_TopLeftTicks
             Line( LoopCounter, self.m_SliderCTL{PROP:YPos} - 4, 0, -Self.m_GradSize)
       end
       If self.m_BottomRightTicks
             Line( LoopCounter, self.m_SliderCTL{PROP:YPos} + 4, 0, Self.m_GradSize)
       end
     end
     SetPenColor()
  end             

!--------------------------------------------------------------------------------------------------------------------------
ODD  Function( ? Number ) !returns "1" if a number is odd
LOC:TestVar  Real
ReturnVal    Byte
  Code

 ReturnVal = 0
 LOC:TestVar = Number / 2
 If ~LOC:TestVar = INT( LOC:TestVar )
   ReturnVal = 1
 end
 Return( ReturnVal )


